'Rip Meedio Movies SQLite database

'ToDo
' + Bekijken welke dbase info nog verwerkt kan worden in de Panel properties
' + Resume Play maken??
' Bioscoop -> Datum en tijd en Bioscoop naam verwerken - Trailer Yes, No
' Toggle Watched flag maken met INSERT etc


Option Explicit
On Error Resume Next

Dim Action
Dim objDB
Dim Status
Dim DataBase
Dim SortOrder
Dim PlayMovieName
Dim MovieList
Dim MovieIndex 'Start movie in alphalist display
Dim MovieCount 'Amount of movies in the dbase
Dim Selection  'All, Watched, UnWatched  
Dim tagOverview
Dim tagPlotsummary
Dim tagGenre
Dim tagActors
Dim tagDirector
Dim tagStudio
Dim tagWriter
Dim tagCopyright
Dim tagWatched
Dim tagTitle
Dim tagSubtitle
Dim tagProduced
Dim tagReleased
Dim tagRuntime
Dim tagReview
Dim tagRating
Dim arrDataBase

                    'Action^       DBase Filename        Panel Title -> Action is set, the rest may vary according own names
arrDataBase = Array("Movies",     "movies.mlf",         "Films", _
		    "HomeVideos", "Home Videos.mlf",    "Home Video's", _
		    "XXXMovies",  "Movies XXX.mlf",     "XXX Films", _
		    "Trailers",   "Movie Trailers.mlf", "Trailers", _
		    "Cinema",     "Film Agenda.mlf",    "Bioscoop")

Const Movies       = 1  'Position in arrDataBase -> Used for HandleMovieControls
Const Trailers     = 10 'Position in arrDataBase -> Used in Get_MovieData
Const Cinema       = 13 'Position in arrDataBase -> Set to 0 if DBase doesn't exist
Const MaxListItems = 120


'-------------------------------------------------------
'- Main ------------------------------------------------
'-------------------------------------------------------
Set objDB      = CreateObject("newObjects.sqlite.dbutf8")
objDB.AutoType = True
Status         = ""
MovieIndex     = 0
DataBase       = arrDataBase(1)
Selection      = "All"
SortOrder      = "item_name ASC"

Call objDB.Open("C:\Program Files\Meedio\Meedio Essentials\library\" & DataBase)
Call Set_Tags(objDB)
objDB.Close

SetPropertyValue "Movies.Selection",  "All"
SetPropertyValue "Movies.Sort Order", "Alphabetic"

Do
	Sleep 1
	Action = GetPropertyValue ("Movies.Action")
	If Action <> "Waiting" Then
		SetpropertyValue "Movies.Action", "Waiting"
		Sleep 100
		If Action <> "" Then
			Call Handle_MoviesAction(objDB, Action)
			If Err.Number <> 0 Then
				Status = "Error: " & Err.Description
				Err.Clear
			End If
			SetPropertyValue "Movies.Status", Status
			Status = ""
		End If
	End If
Loop

Set objDB = Nothing


'-------------------------------------------------------
'- Handle Actions --------------------------------------
'-------------------------------------------------------
Sub Handle_MoviesAction(objDB, Action)
Dim objRow
Dim Data

	Call objDB.Open("C:\Program Files\Meedio\Meedio Essentials\library\" & DataBase)
	Data = Split(Action, "^") 'No Underscore because many filenames use underscores!

	Select Case Data(0)
		Case "Refresh"  : Call Refresh_Panel(objDB)
		Case "DataBase" : Call Set_DataBase(objDB, Data(1))
		Case "Select"   : Call Get_MovieList(objDB, Data(1))       'Selection: All, Watched, UnWatched
		Case "MovieName": Call Get_MovieData(objDB, Data(1))       'Selection from Alphalist containing Movie Names
		Case "SortOrder": Call Set_SortOrder(objDB, Data(1))
		Case "SendKey"  : Call SendKey(Data(1))                    'Selection a .. z
		Case "Ratings"  : Call DisplayRatings(Data(1))             'Selection NL and US
		Case "Control"  : Call HandleMovieControls(objDB, Data(1)) 'Play, Stop, Pause
		Case "Index"    : Call Set_Index(objDB, Data(1))           'Start, End, Prev, Next (Used for alphalist display)
	End Select

	objDB.Close
End Sub


'-------------------------------------------------------
'- Refresh Panel refreshes all data upon Panel Entry ---
'-------------------------------------------------------
Sub Refresh_Panel(objDB)
Dim objRow

	MovieIndex = 0
	Call Set_Tags(objDB)
	'First set the count properties then in the Select Case, the count that gets set again is the true count used for Indexing
	Call Set_TotalCount(objDB)
	Call Set_WatchedCount(objDB)
	Call Set_UnWatchedCount(objDB)
	SetPropertyValue "Movies.Selection", Selection

	Select Case Selection
		Case "All":
			Call Set_TotalCount(objDB) 'Reset Count for indexing because the UnWatched Count is still Set here
			Set objRow = objDB.Execute("SELECT DISTINCT item_name FROM items ORDER BY " & SortOrder & _
						   " LIMIT " & MovieIndex & ", " & MaxListItems)
			Call Fill_NameList(objRow)
			Set objRow = Nothing
			
		Case "Watched":
			If tagWatched <> "--" Then
				Call Set_WatchedCount(objDB) 'Reset Count for indexing because the UnWatched Count is still Set here
				Set objRow = objDB.Execute("SELECT DISTINCT item_name FROM items WHERE " & _
							    tagWatched & " = 'True' ORDER BY " & _
							    SortOrder & " LIMIT " & MovieIndex & ", " & MaxListItems)
				Call Fill_NameList(objRow)
				If objRow.Count = 0 Then
					Set objRow = Nothing
					Selection  = "All"
					Call Handle_MoviesAction(objDB, "Refresh") 'Somekind of Re Call to reset data if this tag doesn't exist
				End If
			Else
				Selection = "All"
				SetPropertyValue "Movies.Watched Count", 0
				Call Handle_MoviesAction(objDB, "Refresh") 'Somekind of Re Call to reset data if this tag doesn't exist
			End If
			
		Case "UnWatched":
			If tagWatched <> "--" Then
				'The UnWatched Count used for indexing is already set here
				Set objRow = objDB.Execute("SELECT DISTINCT item_name FROM items WHERE " & _
							    tagWatched & " = 'False' ORDER BY " & _
							    SortOrder & " LIMIT " & MovieIndex & ", " & MaxListItems)
				Call Fill_NameList(objRow)
				If objRow.Count = 0 Then
					Set objRow = Nothing
					Selection  = "All"
					Call Handle_MoviesAction(objDB, "Refresh") 'Somekind of Re Call to reset data if this tag doesn't exist
				End If
			Else
				Selection = "All"
				SetPropertyValue "Movies.UnWatched Count", 0
				Call Handle_MoviesAction(objDB, "Refresh") 'Somekind of Re Call to reset data if this tag doesn't exist
			End If
	End Select
End Sub


'-------------------------------------------------------
'- Select the database ---------------------------------
'-------------------------------------------------------
Sub Set_DataBase(objDB, Data)
Dim nit
Dim strDBaseTitle
Dim OldDataBase

	OldDataBase   = DataBase 'If a database is selected which is already selected -> don't do anything
	DataBase      = arrDataBase(1)
	strDBaseTitle = arrDataBase(2)

	For nit = 0 To UBound(arrDataBase) step 3
		If Data = arrDataBase(nit) Then
			DataBase      = arrDataBase(nit + 1)
			strDBaseTitle = arrDataBase(nit + 2)
		End If			
	Next

	OpenRemotePanel("M_HB_Films")

	If OldDataBase <> DataBase Then
		SetPropertyValue "Movies.DataBase", strDBaseTitle
		objDB.Close 'This needs to be here because a Call is made which opens the new database
		Call Handle_MoviesAction(objDB, "Refresh")
	End If
End Sub


'-------------------------------------------------------
'- Fill alphalist with Movie Names. 3 Selections -------
'-------------------------------------------------------
Sub Get_MovieList(objDB, Data)
Dim objRow

	Select Case Data
		Case "All":
			Selection = "All"
			Set objRow = objDB.Execute("SELECT DISTINCT item_name FROM items")
			MovieCount = objRow.Count
			Set objRow = Nothing
			
			If MovieIndex >= MovieCount Then
				MovieIndex = 0
			End If

			Set objRow = objDB.Execute("SELECT DISTINCT item_name FROM items ORDER BY " & SortOrder & _
						   " LIMIT " & MovieIndex & ", " & MaxListItems)
			Call Fill_NameList(objRow)
			Set objRow = Nothing
		Case "Watched":
			Selection = "Watched"
			If tagWatched <> "--" Then
				Set objRow = objDB.Execute("SELECT DISTINCT item_name FROM items WHERE " & tagWatched & " = 'True'")
				MovieCount = objRow.Count
				Set objRow = Nothing

				If MovieIndex >= MovieCount Then
					MovieIndex = 0
				End If
	
				Set objRow = objDB.Execute("SELECT DISTINCT item_name FROM items WHERE " & tagWatched & _
							   " = 'True' ORDER BY " & SortOrder & _
							   " LIMIT " & MovieIndex & ", " & MaxListItems)
				Call Fill_NameList(objRow)
				Set objRow = Nothing
			Else
				Selection = "All"
			End If
		Case "UnWatched":
			Selection = "UnWatched"
			If tagWatched <> "--" Then
				Set objRow = objDB.Execute("SELECT DISTINCT item_name FROM items WHERE " & tagWatched & " = 'False'")
				MovieCount = objRow.Count
				Set objRow = Nothing
			
				If MovieIndex >= MovieCount Then
					MovieIndex = 0
				End If

				Set objRow = objDB.Execute("SELECT DISTINCT item_name FROM items WHERE " & tagWatched & _
							   " = 'False' ORDER BY " & SortOrder & _
							   " LIMIT " & MovieIndex & ", " & MaxListItems)
				Call Fill_NameList(objRow)
				Set objRow = Nothing
			Else
				Selection = "All"
			End If
	End Select
	SetPropertyValue "Movies.Selection", Selection
End Sub 


'-------------------------------------------------------
'- Display Movie Data when a movie is selected from the list
'-------------------------------------------------------
Sub Get_MovieData(objDB, MovieName)
Dim objRow
Dim FileSystem
Dim RatingPath
Dim ThumbnailName
Dim RatingName

	MovieName  = Replace(MovieName, "'", "_")
	RatingPath = "C:\Program Files\Meedio\Meedio HouseBot\Config\Themes\Meedio Autohome\Movies\Ratings\"

	'No sort order needed since we select just one movie title here
	Set objRow = objDB.Execute("SELECT * FROM items WHERE item_name LIKE '" & MovieName & "'")

	If objRow.Count > 0 Then
		PlayMovieName = MovieName 'Global variable used in PlayMovie sub gets set here
		ThumbnailName = Get_Item(objRow, 1, "item_image")
		RatingName    = Get_Item(objRow, 1, tagRating)
		Call Set_ReviewData(objDB, objRow)
		SetPropertyValue "Movies.Title",    Get_Item(objRow, 1, tagTitle)
		SetPropertyValue "Movies.Subtitle", Get_Item(objRow, 1, tagSubtitle)
		SetPropertyValue "Movies.Genre",    Set_ListViewData(objDB, objRow, tagGenre)
		SetPropertyValue "Movies.Runtime",  Get_Item(objRow, 1, tagRuntime)
		SetPropertyValue "Movies.Cast",     Set_ListViewData(objDB, objRow, tagActors)
		SetPropertyValue "Movies.Overview", Set_ListViewData(objDB, objRow, tagOverview)
		If DataBase = arrDataBase(Trailers) Then
			SetPropertyValue "Movies.Produced", Get_Item(objRow, 1, tagProduced) & "       Released: "  & Get_Item(objRow, 1, tagReleased)
			SetPropertyValue "Movies.Director", Set_ListViewData(objDB, objRow, tagDirector) & "       Studio: "    & Get_Item(objRow, 1, tagStudio)
			SetPropertyValue "Movies.Writer",   Set_ListViewData(objDB, objRow, tagWriter) & "       " & Replace(Get_Item(objRow, 1, tagCopyright), "?", "")
		Else
			SetPropertyValue "Movies.Produced", Get_Item(objRow, 1, tagProduced)
			SetPropertyValue "Movies.Director", Set_ListViewData(objDB, objRow, tagDirector)
			SetPropertyValue "Movies.Writer",   Set_ListViewData(objDB, objRow, tagWriter)
		End If
	End If

	Set FileSystem = CreateObject("Scripting.FileSystemObject")
	If FileSystem.FileExists(ThumbnailName) = False Or (LCase(Right(ThumbnailName, 3)) <> "jpg" And LCase(Right(ThumbnailName, 3)) <> "png") Then
		Status = Right(ThumbnailName, 20)
		ThumbnailName = "C:\Program Files\Meedio\Meedio HouseBot\Config\Themes\Meedio Autohome\Movies\No Image.jpg"
	End If
	
	If FileSystem.FileExists(RatingPath & RatingName & ".png") = False Then
		SetPropertyValue "Movies.Rating", RatingName 'Only Display Rating when Image is not found
		RatingName = "No Rating"
	Else
		SetPropertyValue "Movies.Rating", ""
	End If
	
	SetPropertyValue "Movies.Thumbnail", ThumbnailName
	SetPropertyValue "Movies.Rating Image", RatingPath & RatingName & ".png"

	Set FileSystem = Nothing
	Set objRow     = Nothing
End Sub


'-------------------------------------------------------
'- This only sets the Sort Order. It will be carried out by Get_MovieList
'-------------------------------------------------------
Sub Set_SortOrder(objDB, Data)

	Select Case Data
		Case "Alphabetic"  : SortOrder = "item_name ASC"
		Case "DownloadDate": SortOrder = "item_date DESC"
		Case "Produced":
			If tagProduced <> "--" Then
				SortOrder = tagProduced & " DESC"
			Else
				Data      = "Alphabetic"
				Sortorder = "item_name ASC"
			End If
		Case "Review":
			If tagReview <> "--" Then
				SortOrder = tagReview & " DESC"
			Else
				Data      = "Alphabetic"
				Sortorder = "item_name ASC"
			End If
		Case "Genre":
			If tagGenre <> "--" Then
				SortOrder = tagGenre & " ASC"
			Else
				Data      = "Alphabetic"
				Sortorder = "item_name ASC"
			End If
		Case Else:
			Data      = "Alphabetic"
			Sortorder = "item_name ASC"
	End Select

	SetPropertyValue "Movies.Sort Order", Data
End Sub


'-------------------------------------------------------
'- Keys a through z are accepted to jump in alphalist --
'-------------------------------------------------------
Sub SendKey(Data)
Dim objShell

	Set objShell = CreateObject ("WScript.Shell")
	objShell.SendKeys Data
	Set objShell = Nothing
End Sub


'-------------------------------------------------------
'- AL, MG6, 9, 12, 16, PG, PG13, R, Dutch and US rating system
'-------------------------------------------------------
Sub DisplayRatings(Data)
Dim FileSystem
Dim RatingPath
Dim RatingImage

	RatingPath = "C:\Program Files\Meedio\Meedio HouseBot\Config\Themes\Meedio Autohome\Movies\Ratings\"

	Select Case Data
		Case "NL": RatingImage = "NL Ratings.png"
		Case "US": RatingImage = "US Ratings.png"
	End Select
	
	Set FileSystem = CreateObject("Scripting.FileSystemObject")
	If FileSystem.FileExists(RatingPath & RatingImage) = False Then
		RatingImage = "No Rating.png"
	End If
	
	SetPropertyValue "Movies.Thumbnail", RatingPath & RatingImage
	Set FileSystem = Nothing
End Sub


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Sub HandleMovieControls(objDB, Data)
Dim nit
Dim objRow
Dim objShell
Dim objMeedioClient
Dim objMessage
Dim ItemLocation
Dim FileName

	Set objRow          = objDB.Execute("SELECT * FROM items WHERE item_name LIKE '" & PlayMovieName & "'")
	Set objShell        = CreateObject("WScript.Shell")
	Set objMeedioClient = CreateObject("MeedioClient.MeedioPluginClient")

	If objMeedioClient.Connect("localhost" ,7500 ,"" ,0 ,0) Then
		objShell.AppActivate "meedio essentials"
		
		ItemLocation = Get_Item(objRow, 1, "item_location")
		'Movies etc begin with and use | as separator and trailers don't
		If Left(ItemLocation, 1) = "|" Then
			FileName = Split(Right(ItemLocation, Len(ItemLocation) - 1), "|")
		Else
			FileName = Split(ItemLocation, "|")
		End If
		
		Select Case Data
			Case "Play":
				SetPropertyValue "Meedio Essentials.Command to send", "BACK" 'Stop a Movie which could be already playing
				Call MovieControl(objMeedioClient, "", "video.clear-queue", "")
				Call MovieControl(objMeedioClient, "", "music.stop", "")
				
				If DataBase = arrDataBase(Movies) Then
					If UBound(FileName) > 0 Then
						For nit = 0 To UBound(FileName) - 1 '- 1 Because the item_location ends with a | separator
							Call MovieControl(objMeedioClient, objRow, "video.add-to-queue", FileName(nit))
						Next
					End If
					
					Call MovieControl(objMeedioClient, objRow, "video.now-playing", FileName(0))
				Else
					Call MovieControl(objMeedioClient, objRow, "standard-action.video.play-file", FileName(0))
				End If
			Case "Stop":
				Call MovieControl(objMeedioClient, "", "video.stop", "")
				Call MovieControl(objMeedioClient, "", "video.clear-queue", "")
			
			Case "Pause":
				Call MovieControl(objMeedioClient, "", "video.pause", "")
		End Select

		Sleep 100
		objMeedioClient.Flush
	End If

	Set objMeedioClient = Nothing
	Set objShell        = Nothing
	Set objRow          = Nothing
End Sub


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Sub Set_Index(objDB, Data)

	Select Case Data
		Case "Start":
			MovieIndex = 0
		Case "End":
			If MovieCount - MaxListItems > 0 Then
				MovieIndex = MovieCount - MaxListItems
			End If
		Case "Prev":
			If MovieIndex - MaxListItems < 0 Then
				MovieIndex = 0
			Else
				MovieIndex = MovieIndex - MaxListItems
			End If
		Case "Next":
			If MovieIndex + MaxListItems < MovieCount Then
				MovieIndex = MovieIndex + MaxListItems
			End If
	End Select
	
	Call Get_MovieList(objDB, Selection)
End Sub


'-------------------------------------------------------
'- Commonly used Subs and Functions --------------------
'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Sub Fill_NameList(objRow)
Dim Row
Dim MovieList

	If objRow.Count > 0 Then
		If IsNull(objRow(1)("item_name")) = False Then
			MovieList = "*S-" & "MovieName^" & objRow(1)("item_name") & vbTAB & objRow(1)("item_name")
		End If
		
		For Row = 2 to objRow.Count
			If IsNull(objRow(Row)("item_name")) = False Then
				MovieList = MovieList & vbLF & "MovieName^" & objRow(Row)("item_name") & vbTAB & objRow(Row)("item_name")
			End If
		Next
		
		If MovieCount < (MovieIndex + MaxListItems) Then
			SetPropertyValue "Movies.Index", MovieIndex + 1 & " - " & MovieCount
		Else
			SetPropertyValue "Movies.Index", MovieIndex + 1 & " - " & MovieIndex + MaxListItems
		End If

		If Len(MovieList) < 9800 Then
			SetPropertyValue "Movies.Name List", MovieList
		Else
			SetPropertyValue "Movies.Name List", "List out of memory. Decrease MaxItemList"
		End If
	End If
End Sub


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Sub Set_ReviewData(objDB, objRow)
Dim Review
Dim Review_Path
Dim Review_Name
Dim Review_Image

	Review      = Split(Get_Item(objRow, 1, tagReview), "/") 'Cinema use 6.7/10 whereas Movies just uses 6.7
	Review_Path = "C:\Program Files\Meedio\Meedio HouseBot\Config\Themes\Meedio Autohome\Movies\Review\"
	Review_Name = "nostars.png"
	SetPropertyValue "Movies.Review", Review(0)

	If Review(0) <> "--" Then
		Review_Image = Review_Path & "stars" & Set_ReviewNr(Review(0)) & "r.png"
	Else
		Review_Image = Review_Path & Review_Name
	End If
	
	SetPropertyValue "Movies.Review Image", Review_Image
End Sub


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Function Set_ReviewNr(ReviewNr)
Dim intFirstDigit
Dim intSecondDigit
Dim strSecondDigit

	ReviewNr       = ReviewNr * 10		'7.4 * 10  = 74
	intFirstDigit  = ReviewNr \ 20		'74  \ 20  = 3
	intSecondDigit = ReviewNr Mod 10	'74 Mod 10 = 4

	Select Case True
		Case intSecondDigit >= 0 And intSecondDigit < 3 : strSecondDigit = ""
		Case intSecondDigit >= 3 and intSecondDigit < 7 : strSecondDigit = "5"
		Case intSecondDigit >= 7 and intSecondDigit <= 9: intFirstDigit  = intFirstDigit + 1 : strSecondDigit = ""
	End Select

	Set_ReviewNr = CStr(intFirstDigit) & strSecondDigit
End Function


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Function Set_ListViewData(objDB, objRow, tagName)
Dim FirstWord
Dim LastWord
Dim DataWords
Dim Data
Dim LineLength(100)
Dim LineCount
Dim Separator
Dim nit

	Data      = ""
	LineCount = 0
	For nit = 0 To 100
		LineLength(nit) = 0
	Next
	
	Select Case tagName
		Case tagOverview, _
		     tagPlotSummary:
			DataWords = Split(Get_Item(objRow, 1, tagName), " ")
			FirstWord = 0
			LastWord  = UBound(DataWords)
			Separator = " "

		Case tagActors, _
		     tagGenre, _
		     tagDirector, _
		     tagWriter:
		     	If DataBase = arrDataBase(Cinema) Then
				DataWords = Split(Get_Item(objRow, 1, tagName), ",")
				FirstWord = 0
				LastWord  = UBound(DataWords)
				Separator = ", "
			Else
				DataWords = Split(Get_Item(objRow, 1, tagName), "|")
				If UBound(DataWords) > 0 Then
					FirstWord = 1
					LastWord  = UBound(DataWords) - 1
				Else
					FirstWord = 0
					LastWord  = 0
				End If
				Separator = ", "
			End If
	End Select
	
	For nit = FirstWord To LastWord
		LineLength(LineCount) = LineLength(LineCount) + Len(DataWords(nit)) + 1 'The + 1 is to include the separators
		If LineLength(LineCount) > 55 Then
			Data      = Data & vbLF
			LineCount = LineCount + 1
		End If

		Data = Data & DataWords(nit)

		If nit < LastWord Then 'Don't display a separator after the last word
			Data = Data & Separator
		End If
	Next
	
	If Data = "" Then
		Data = " "
	End If
	Set_ListViewData = Data
End Function


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Sub MovieControl(objMeedioClient, objRow, strCommand, FileName)
Dim objMessage

	Set objMessage = objMeedioClient.NewMessage(strCommand)
	
	If FileName <> "" Then
		objMessage("file")        = FileName
		objMessage("section")     = DataBase
		objMessage("external-id") = Get_Item(objRow, 1, "item_ext_id")
	End If
	
	objMessage.Send
	Set objMessage = Nothing
	Sleep 500

	If objRow <> "" Then
		Set objMessage = objMeedioClient.NewMessage("video.event.display-change")
		objMessage("visible")     = True
		objMessage("status")      = Get_Item(objRow, 1, tagOverview)
		objMessage("destination") = "addl-info"
		objMessage.Send
		Set objMessage = Nothing
		Sleep 500
	End If
End Sub


'-------------------------------------------------------
'- Set all Tag names -> Global variables ---------------
'-------------------------------------------------------
Sub Set_Tags(objDB)
	
	tagOverview    = Get_Tag(objDB, "Overview")
	tagPlotsummary = Get_Tag(objDB, "Plotsummary")
	tagGenre       = Get_Tag(objDB, "Genre")
	tagActors      = Get_Tag(objDB, "Actors")
	tagDirector    = Get_Tag(objDB, "Director")
	tagStudio      = Get_Tag(objDB, "Studio")
	tagWriter      = Get_Tag(objDB, "Writer")
	tagCopyright   = Get_Tag(objDB, "Copyright")
	tagWatched     = Get_Tag(objDB, "Watched")
	tagTitle       = Get_Tag(objDB, "Title")
	tagSubtitle    = Get_Tag(objDB, "Subtitle")
	tagProduced    = Get_Tag(objDB, "Produced")
	tagReleased    = Get_Tag(objDB, "Released")
	tagRuntime     = Get_Tag(objDB, "Runtime")
	tagReview      = Get_Tag(objDB, "Review")
	tagRating      = Get_Tag(objDB, "Rating") 
End Sub


'-------------------------------------------------------
'- Get a tagName and handle differences between dbases -
'-------------------------------------------------------
Function Get_Tag(objDB, tagName)
Dim tagValue

	Get_Tag = "--"
	
	Select Case tagName:
		Case "Overview":
			If Check_Tag(objDB, tagName) <> "--" Then
				Get_Tag = Check_Tag(objDB, tagName)
			Else
				If Check_Tag(objDB, "PlotSummary") <> "--" Then
					Get_Tag = Check_Tag(objDB, "PlotSummary")
				End If
			End If
			
		Case "Title":
			If Check_Tag(objDB, "_itle") <> "--" Then
				Get_Tag = Check_Tag(objDB, "_itle") '%itle would confilct with subtitle. Underscore not really necessary because LIKE is case insensitive
			End If

		Case Else:
			Get_Tag = Check_Tag(objDB, "%" & Right(tagName, Len(tagName) - 1)) '% Here so Review and IMDBUserReview both work
	End Select
End Function


'-------------------------------------------------------
'- Sub Function called from Get_Tag --------------------
'-------------------------------------------------------
Function Check_Tag(objDB, tagName)
Dim objRow
Dim tagValue

	Check_Tag  = "--"
	Set objRow = objDB.Execute("SELECT * FROM tags WHERE tag_name LIKE '" & tagName & "'")

	If objRow.Count > 0 Then
		If IsNull(objRow(1)("tag_col")) = False Then
			tagValue = objRow(1)("tag_col")
			If tagValue <> "" Then
				Check_Tag = tagValue
			End If
		End If
	End If
	
	Set objRow = Nothing
End Function


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Function Get_Item(objRow, Row, ItemLabel)
Dim Itemvalue

	Get_Item = "--"
	If objRow.Count > 0 Then
		If IsNull(objRow(Row)(ItemLabel)) = False Then
			ItemValue = objRow(Row)(ItemLabel)
			If ItemValue <> "" Then
				Get_Item = ItemValue
			End If
		End If
	End If
End Function


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Sub Set_TotalCount(objDB)
Dim objRow

	Set objRow = objDB.Execute("SELECT DISTINCT item_name FROM items")
	MovieCount = objRow.Count 'First get the total item count and thereafter do the selection with SortOrder and Limit
	Set objRow = Nothing
	SetPropertyValue "Movies.Total Count", MovieCount
End Sub


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Sub Set_WatchedCount(objDB)
Dim objRow

	If Get_Tag(objDB, "Watched") <> "--" Then
		Set objRow = objDB.Execute("SELECT DISTINCT item_name FROM items WHERE " & Get_Tag(objDB, "Watched") & " = 'True'")
		SetPropertyValue "Movies.Watched Count", objRow.Count
		MovieCount = objRow.Count
		Set objRow = Nothing
	Else
		SetPropertyValue "Movies.Watched Count", 0
	End If
End Sub


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Sub Set_UnWatchedCount(objDB)
Dim objRow

	If Get_Tag(objDB, "Watched") <> "--" Then
		Set objRow = objDB.Execute("SELECT DISTINCT item_name FROM items WHERE " & Get_Tag(objDB, "Watched") & " = 'False'")
		SetPropertyValue "Movies.UnWatched Count", objRow.Count
		MovieCount = objRow.Count
		Set objRow = Nothing
	Else
		SetPropertyValue "Movies.UnWatched Count", 0
	End If
End Sub
				